package com.qls.ali.biz.config;

import org.springframework.amqp.rabbit.config.SimpleRabbitListenerContainerFactory;
import org.springframework.amqp.rabbit.connection.ConnectionFactory;
import org.springframework.boot.autoconfigure.amqp.SimpleRabbitListenerContainerFactoryConfigurer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Profile;

/**
 * @author doyoung
 */
@Profile("single")
@Configuration
public class RabbitListenerConfig {


    @Bean("rates")
    public SimpleRabbitListenerContainerFactory rates(SimpleRabbitListenerContainerFactoryConfigurer configurer,ConnectionFactory connectionFactory) {
        SimpleRabbitListenerContainerFactory factory = new SimpleRabbitListenerContainerFactory();
        factory.setConnectionFactory(connectionFactory);
        factory.setBatchListener(true);
        factory.setConsumerBatchEnabled(true);
        factory.setPrefetchCount(100);
        factory.setConcurrentConsumers(50);
        factory.setMaxConcurrentConsumers(100);
        configurer.configure(factory, connectionFactory);
        return factory;
    }

    @Bean("rp")
    public SimpleRabbitListenerContainerFactory rpContainerFactory(SimpleRabbitListenerContainerFactoryConfigurer configurer,
                                                                   ConnectionFactory connectionFactory) {
        SimpleRabbitListenerContainerFactory factory = new SimpleRabbitListenerContainerFactory();
        factory.setConcurrentConsumers(2);
        factory.setPrefetchCount(1);
        factory.setMaxConcurrentConsumers(3);
        configurer.configure(factory, connectionFactory);
        return factory;
    }

}
