package com.qls.ali.biz.config;


import cn.hutool.core.convert.Convert;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.thread.ThreadUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import com.qls.core.dto.BatchPushRatesBody;
import com.qls.core.dto.PushRatesBody;
import com.qls.core.dto.PushRpBody;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Component;
import com.qls.ali.biz.data.controller.RatesController;
import com.qls.ali.biz.data.controller.RpController;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


/**
 * @author doyoung
 */
@Profile("single")
@Component
@Slf4j
public class ReceiveHandler {

    @Value("${storeid}")
    private String storeId="1";

    @Autowired
    private RatesController ratesController;

    @Autowired
    private RpController rpController;

    @RabbitListener(queues = "${storeid}_rates", containerFactory = "rates")
    public void rates(List<PushRatesBody> pushRatesBodies) {
        Iterator<PushRatesBody> iterator = pushRatesBodies.iterator();
        while (iterator.hasNext()){
            PushRatesBody pushRatesBody = iterator.next();
            if (pushRatesBody.getRpCode()==null||pushRatesBody.getRpCode().equals(-1L)) {
                iterator.remove();
            }
        }
        BatchPushRatesBody batchPushRatesBody = new BatchPushRatesBody();
        batchPushRatesBody.setPushRatesBodies(pushRatesBodies);
        batchPushRatesBody.setStoreId(Convert.toInt(storeId));
        ratesController.push(batchPushRatesBody);
    }

    @RabbitListener(queues = "${storeid}_rp", containerFactory = "rp")
    public void rp(PushRpBody msg) {
        Integer taskId = msg.getTaskId();
        if (msg.getRpCode().equals(-1L)) {
            return;
        }
        msg.setStoreId(Convert.toInt(storeId));
        rpController.push(msg);
    }


}
